extern char *malloc(), *realloc();

# line 6 "gram.y"
#include <stdio.h>
#include <math.h>
#include "art.h"
#include "macro.h"

extern object	*objectinit(),
		*compinit(),
		*csginit(),
		*getcsgobj(),
		*getcsgexp();

extern symbol	*lookup();

extern light	*lightinit();
extern texture	*textureinit();
extern wlist	*waveinit();
extern cmap	*mapinit();

extern attr	*astackp;
extern mats	*mstackp;

extern object	*oblist;
extern light	*lights;

extern vector	org, up;

extern matrix	trans;
extern float	focallength;

extern char	*title;
extern int	maxhitlevel, raysperpix, pixelgrid;
extern long	filetype;

extern colour	backcol;

extern float	fogfactor, rfactor;
extern colour	hazecolour;

extern float	sourceradius;
extern float	falloff;
extern float	ri;

extern float	screenx, screeny;
extern int	maxtreedepth;
extern int	perspective;

extern int	frameno;

extern float		eval_fexpr();
extern int		eval_iexpr();
extern expression	*get_expr(), *get_varexpr();

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif

static int	objdefined = FALSE;
static int	fieldtype;

extern objst	*ostackp;


# line 69 "gram.y"
typedef union {
	object		*y_obj;
	vector		*y_pnt;
	details		*y_det;
	char		*y_str;
	eqn		*y_eqn;
	term		*y_trm;
	expression	*y_exp;
	symbol		*y_sym;
	csgnode		*y_csg;
	float		y_flt;
	int		y_int;
} YYSTYPE;
# define CSG 257
# define COMPOSITE 258
# define OBJECT_TYPE 259
# define FLOAT 260
# define INTEGER 261
# define FILETYPE 262
# define OPTION 263
# define NAME 264
# define LBRACE 265
# define RBRACE 266
# define LP 267
# define RP 268
# define RADIUS 269
# define RADII 270
# define COLOUR 271
# define CENTER 272
# define VERTEX 273
# define COMMA 274
# define PCENT 275
# define MATERIAL 276
# define REFI 277
# define MINUS 278
# define AMBIENT 279
# define INTENSITY 280
# define LOCATION 281
# define DOLS 282
# define EQUATION 283
# define OFFFILE 284
# define BASE 285
# define TOP 286
# define CONST 287
# define COEFFS 288
# define SCALE 289
# define ROTATE 290
# define TRANSLATE 291
# define TITLE 292
# define REFLECTANCE 293
# define DOT 294
# define ON 295
# define OFF 296
# define LOOKAT 297
# define FIELDOFVIEW 298
# define TRANSPARENCY 299
# define RAYSPERPIXEL 300
# define BACKGROUND 301
# define SIZE 302
# define MAXHITLEVEL 303
# define OUTPUT 304
# define ORDER 305
# define ABSORPTION 306
# define VREF1 307
# define VREF2 308
# define NUMRAYS 309
# define OBJECT 310
# define TEXTURE 311
# define DIRECTION 312
# define ANGLE 313
# define UP 314
# define TWENTYFIVEBIT 315
# define RANGE 316
# define MAP 317
# define BLENDCOLOR 318
# define SCALEFACTORS 319
# define VORTFILE 320
# define HAZECOLOUR 321
# define FOGFACTOR 322
# define RFACTOR 323
# define FALLOFF 324
# define QUOTE 325
# define REPEAT 326
# define SHADOWS 327
# define COLOURFILE 328
# define VNORMALFILE 329
# define SCALEFACTOR 330
# define SOURCE 331
# define AMPLITUDE 332
# define WAVELENGTH 333
# define PHASE 334
# define TURBULENCE 335
# define SQUEEZE 336
# define DAMPING 337
# define SOURCERADIUS 338
# define NORMAL 339
# define COMPLEXVERTEX 340
# define SCREENSIZE 341
# define MAXTREEDEPTH 342
# define BLEND 343
# define COLOURMAP 344
# define MAPVALUES 345
# define PIXELGRID 346
# define RI 347
# define COLOURBLEND 348
# define NORMALFILE 349
# define BEAMDISTRIBUTION 350
# define INSIDEANGLE 351
# define PROJECTION 352
# define PERSPECTIVE 353
# define ORTHOGRAPHIC 354
# define STRIP 355
# define VCOLOURFILE 356
# define TRANSFORM 357
# define MINDIST 358
# define CLIPVOLUME 359
# define HEIGHTFIELD 360
# define FRAMENO 361
# define BLOCKSIZE 362
# define GAPCOLOUR 363
# define GAPSIZE 364
# define COLOURFIELD 365
# define PLUS 366
# define MULT 367
# define DIV 368
# define POWER 369
# define UMINUS 370
# define EQUALS 371
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 170
# define YYLAST 1617
int yyact[]={

   192,   244,   329,   467,   362,   104,   259,   152,    72,    79,
    80,    81,    82,    83,    84,    85,   153,   154,   391,   345,
    91,    92,   222,    94,   403,    95,    96,   229,   169,    28,
   346,   105,   141,   142,    86,   267,   118,   111,   112,   113,
   117,   177,   469,   120,   121,   122,   123,    33,    31,    32,
   152,   133,   134,   368,   152,   132,    87,    88,   408,   152,
   206,   369,   150,   361,   144,   110,   145,   146,   147,   148,
   149,   108,   107,   399,   204,   201,   205,   207,   209,   156,
   465,   106,    90,    89,   152,   102,   101,   318,   208,   212,
   159,   160,   101,   210,   211,   151,   153,   154,    99,   184,
   185,   203,   202,   183,   168,    97,   182,   171,   172,   173,
   174,   175,   103,   100,    99,    34,   279,   178,   344,   345,
   215,   214,   213,   184,   185,    98,    97,   183,   117,   348,
   182,   463,   269,   186,   349,   152,   167,   296,   151,   153,
   154,   257,   151,   153,   154,   216,   461,   151,   153,   154,
   152,   217,   218,   219,   220,   221,   165,   163,   223,   224,
   127,   458,   227,   109,   459,   119,   323,   100,   152,   102,
   243,   152,   151,   153,   154,   104,    93,   250,   117,   114,
   253,   455,    98,   453,   276,   152,   454,   268,   261,   117,
   152,   264,   234,   152,   266,   155,   143,   131,   449,   130,
   129,   128,   152,   206,   270,   271,   272,   273,   274,   275,
   126,   277,   278,   125,   280,   281,   282,   204,   201,   205,
   207,   209,   326,   151,   153,   154,   286,   287,   392,   256,
   124,   208,   212,    71,   254,   241,   210,   211,   151,   153,
   154,   152,   115,   242,   203,   202,   306,   307,   308,   309,
   310,   164,   435,   312,   140,   314,   151,   153,   154,   151,
   153,   154,   152,   215,   214,   213,   322,   139,   234,   293,
   330,   138,   303,   151,   153,   154,   137,   434,   151,   153,
   154,   151,   153,   154,   337,   338,   339,   152,   136,   342,
   151,   153,   154,   135,   448,   327,   166,   447,   152,     4,
     2,   152,   351,   294,   443,     5,   352,   189,   152,     1,
   328,   442,   358,   424,   360,   152,   236,   375,     3,   363,
   334,   364,   365,   152,   188,   181,   439,     0,   293,   151,
   153,   154,   371,   372,   373,     0,   381,   382,   152,   441,
     0,   385,   386,   152,   428,     0,     0,     0,   152,     0,
   151,   153,   154,   423,     0,   393,   394,   395,   396,   367,
   397,   255,     0,   152,     0,   422,   200,   402,   263,   152,
   330,   405,   404,     0,     0,   151,   153,   154,   409,   410,
   411,   412,     0,     0,   415,   416,   151,   153,   154,   151,
   153,   154,     0,     0,   419,   327,   151,   153,   154,   425,
   426,     0,   427,   151,   153,   154,   400,   429,   430,   431,
     0,   151,   153,   154,   432,   433,     0,   240,   152,   436,
   251,    73,    74,   438,     0,    77,   151,   153,   154,   440,
   421,   151,   153,   154,     0,     0,   151,   153,   154,    78,
   152,     0,   444,   445,   446,     0,     0,   303,   450,   451,
   452,   151,   153,   154,     0,   456,   457,   151,   153,   154,
   460,     0,   462,   418,   464,   343,   466,   152,   468,    26,
    25,    24,   193,   191,     0,    62,    27,   346,   300,     0,
   180,    37,    38,    56,    35,    39,    76,     0,    54,   324,
     0,    57,     0,    64,     0,    40,    48,    45,    44,    43,
    42,    33,    31,    32,     6,    58,   151,   153,   154,    18,
     7,    59,    10,    19,     0,    20,    21,    36,    61,     0,
     0,    65,    75,    63,    70,    69,    17,    16,   151,   153,
   154,   162,   420,    11,    12,    13,    22,   417,    30,    55,
    51,    52,   152,     0,   258,     0,     0,   152,   414,     0,
    14,     0,   152,     8,     9,   151,   153,   154,    15,    60,
     0,    53,    67,    66,    23,   344,   345,    49,    50,    34,
    68,    41,    46,   298,   299,   295,     0,    47,     0,    62,
   297,     0,     0,   296,     0,    37,    38,    56,    35,    39,
     0,     0,    54,     0,     0,    57,     0,    64,     0,    40,
    48,    45,    44,    43,    42,    33,    31,    32,     0,    58,
   194,   195,   196,   197,   198,    59,   353,     0,   315,   316,
   170,    36,    61,     0,     0,    65,   152,    63,    70,    69,
   151,   153,   154,   152,     0,   151,   153,   154,   390,     0,
   151,   153,   154,    55,    51,    52,   413,     0,   346,   407,
   152,     0,   406,   152,     0,     0,   152,     0,   401,     0,
     0,     0,   152,    60,   398,    53,    67,    66,   152,     0,
     0,    49,    50,    34,    68,    41,    46,   239,   238,   237,
     0,    47,     0,    62,   231,     0,   290,     0,     0,    37,
    38,    56,    35,    39,     0,   232,    54,     0,     0,    57,
     0,    64,     0,    40,    48,    45,    44,    43,    42,    33,
    31,    32,     0,    58,   151,   153,   154,     0,   260,    59,
     0,   151,   153,   154,     0,    36,    61,     0,     0,    65,
     0,    63,    70,    69,     0,     0,   344,   345,   151,   153,
   154,   151,   153,   154,   151,   153,   154,    55,    51,    52,
   151,   153,   154,     0,     0,   384,   151,   153,   154,   152,
     0,     0,   383,     0,     0,     0,   152,    60,   370,    53,
    67,    66,   152,     0,     0,    49,    50,    34,    68,    41,
    46,   239,   238,   237,     0,    47,     0,    62,   231,     0,
   233,     0,     0,    37,    38,    56,    35,    39,     0,     0,
    54,     0,     0,    57,     0,    64,     0,    40,    48,    45,
    44,    43,    42,    33,    31,    32,     0,    58,     0,     0,
     0,     0,     0,    59,   366,     0,     0,     0,   152,    36,
    61,     0,     0,    65,     0,    63,    70,    69,     0,     0,
     0,     0,     0,     0,     0,     0,   359,   151,   153,   154,
   152,    55,    51,    52,   151,   153,   154,     0,     0,     0,
   151,   153,   154,   357,     0,     0,   356,   152,     0,     0,
   152,    60,   355,    53,    67,    66,   152,     0,     0,    49,
    50,    34,    68,    41,    46,    62,   231,     0,   319,    47,
     0,    37,    38,    56,    35,    39,    73,    74,    54,     0,
    77,    57,     0,    64,     0,    40,    48,    45,    44,    43,
    42,    33,    31,    32,    78,    58,   151,   153,   154,     0,
     0,    59,   354,     0,     0,     0,   152,    36,    61,     0,
     0,    65,     0,    63,    70,    69,     0,     0,   151,   153,
   154,     0,   341,     0,     0,     0,   152,     0,   340,    55,
    51,    52,   152,     0,     0,   151,   153,   154,   151,   153,
   154,    76,     0,   336,   151,   153,   154,   152,     0,    60,
   335,    53,    67,    66,   152,     0,     0,    49,    50,    34,
    68,    41,    46,    62,   231,     0,   289,    47,     0,    37,
    38,    56,    35,    39,     0,     0,    54,    75,     0,    57,
     0,    64,     0,    40,    48,    45,    44,    43,    42,    33,
    31,    32,     0,    58,   151,   153,   154,     0,     0,    59,
   333,     0,     0,     0,   152,    36,    61,     0,     0,    65,
     0,    63,    70,    69,   151,   153,   154,     0,     0,     0,
   151,   153,   154,     0,     0,     0,   332,    55,    51,    52,
   152,     0,     0,     0,   374,   151,   153,   154,     0,     0,
   376,   331,   151,   153,   154,   152,     0,    60,   321,    53,
    67,    66,   152,     0,     0,    49,    50,    34,    68,    41,
    46,    62,   231,     0,   228,    47,     0,    37,    38,    56,
    35,    39,     0,     0,    54,     0,     0,    57,     0,    64,
     0,    40,    48,    45,    44,    43,    42,    33,    31,    32,
     0,    58,   151,   153,   154,   320,     0,    59,   291,   152,
   378,   377,   379,    36,    61,   380,     0,    65,     0,    63,
    70,    69,     0,     0,   325,     0,     0,     0,   151,   153,
   154,     0,     0,     0,     0,    55,    51,    52,     0,     0,
     0,     0,   313,   151,   153,   154,   152,    33,    31,    32,
   151,   153,   154,   199,     0,    60,     0,    53,    67,    66,
   206,     0,     0,    49,    50,    34,    68,    41,    46,     0,
     0,     0,     0,    47,   204,   201,   205,   207,   209,   311,
     0,     0,   301,   152,     0,     0,   152,   288,   208,   212,
   206,   152,   285,   210,   211,     0,   152,   151,   153,   154,
     0,   203,   202,     0,   204,   201,   205,   207,   209,   184,
   185,     0,     0,   183,     0,    34,   182,   317,   208,   212,
   215,   214,   213,   210,   211,   284,     0,   257,     0,   152,
     0,   203,   202,   283,   151,   153,   154,   152,   265,     0,
     0,   252,   152,     0,   249,   152,     0,     0,   152,   248,
   215,   214,   213,   152,   247,     0,     0,   246,   152,     0,
   245,   152,     0,   226,   152,     0,   225,   152,     0,     0,
   152,   151,   153,   154,   151,   153,   154,     0,   190,   151,
   153,   154,   152,   187,   151,   153,   154,   152,   179,     0,
     0,   176,   152,     0,   161,   152,     0,   158,   152,     0,
   157,   152,    73,    74,   152,   230,    77,    29,   262,   116,
     0,     0,     0,     0,     0,   256,     0,   151,   153,   154,
    78,     0,     0,     0,     0,   151,   153,   154,     0,     0,
   151,   153,   154,   151,   153,   154,   151,   153,   154,     0,
     0,   151,   153,   154,     0,     0,   151,   153,   154,   151,
   153,   154,   151,   153,   154,   151,   153,   154,   151,   153,
   154,    73,    74,     0,     0,    77,   304,    76,   116,     0,
   151,   153,   154,   437,     0,   151,   153,   154,     0,    78,
   151,   153,   154,   151,   153,   154,   151,   153,   154,   151,
   153,   154,   151,   153,   154,     0,    33,    31,    32,   304,
     0,     0,     0,    75,     0,   347,   302,     0,     0,   350,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    76,     0,     0,    33,
    31,    32,     0,   305,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   387,   388,   389,     0,     0,     0,     0,
     0,     0,    75,     0,    34,     0,   305,     0,     0,     0,
   235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    34,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   235,   292,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   292 };
int yypact[]={

 -1000,   212, -1000, -1000, -1000, -1000,   -31,   636,   636,   636,
   636,   636,   636,   636,   636,  -261,  -239,  -184,  -185,   636,
   636,   -86,   636,  -328,  -139,  -151,  -179,  -259, -1000, -1000,
   636,  -186,  -195,  -196,  -102,  -202,   636,   636,   636,  1111,
  -246,   -94,   636,   636,   636,   636,   -34,   -51,   -54,  -105,
   -63,   -64,   -65,   -67,   636,  -244, -1000, -1000, -1000, -1000,
 -1000, -1000,  -263,   -68,  -203,   636,   636,   636,   636,   636,
  -205, -1000,  -228, -1000, -1000, -1000,   -69, -1000,   636,  1036,
  -228,  -228,  1033,  -228,  -228,  -228, -1000, -1000, -1000,   636,
   636,  1030,  -228, -1000,  -228, -1000, -1000, -1000,  -108, -1000,
  -109, -1000,  -129,   636,  -274,   355,   636,   636,   636,   636,
   636,  -228,  -228,  1027,  -233, -1000,   636,  1024,  -161,  -132,
  1019,  -228,  -228,  -228, -1000, -1000, -1000,  1111, -1000, -1000,
 -1000, -1000,  1014, -1000, -1000,   161,   161,   161,   161,   161,
   161, -1000, -1000,   898,   636,  -228,  -228,  -228,  -228,  -228,
   636,   636,   636,   636,   636,  -303, -1000,   636,   636,  1002,
   999,   636,   818, -1000,   524, -1000, -1000, -1000,  -228,   636,
 -1000,   996,   993,   990,   985,   980,   636,  1111,   977,   636,
  -137, -1000,  -161,  -363, -1000, -1000, -1000,   636,  1052,  -233,
   636, -1000,   974,   -70, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000,   -77,  -133,   636,   636,   636,   636,   636,   636,   -80,
   636,   636,  -149,   636,   636,   636,   969,   961,  -351,  -351,
 -1000, -1000, -1000,  -228,   928,   636,   636,   923, -1000, -1000,
 -1000,   -89,   720, -1000, -1000, -1000, -1000,  -160,  -167,  -173,
   420,   316, -1000,   918,  1150,   636,   636,   636,   636,   636,
   915, -1000,   636,   878,   636,  -161,  -161,  -161,   959,  -178,
   622,   841, -1000,  -233,   794,   636,   -99,   868, -1000,   636,
  -228,  -228,   787,   772,   746,  -228, -1000,  -228,  -228, -1000,
  -228,   696,   689,   636,   636,   636,   674,   668,   636, -1000,
 -1000,   199, -1000, -1000, -1000,   -82,  -130,   -89,   -95,   -97,
   316,   636, -1000, -1000, -1000,   636,   348,   648,   598,   592,
   589,   636,   572,   636,  -219,  -161,  -161,  -365,   636, -1000,
   636,   636,   550, -1000, -1000, -1000, -1000, -1000,  -213, -1000,
   494,   636,   636,   636,   788,   636,   636,   488,   481,  -228,
   636,   636,  -228, -1000,  -130,  -130,  -130,   370, -1000, -1000,
  -248,  -228,   -37, -1000,   636,   636,   636,   636,  -228,   636,
   390, -1000,  -192,   140,  -228,   384,   636,  -242, -1000,   636,
   636,   378,  -228,   375, -1000, -1000,  -209,   636,   636,   636,
   636,   372,   274,   636,   636,   269,   189,  -348, -1000,  -348,
 -1000, -1000, -1000,   264,   162,    91,    85,    45,   636,   636,
 -1000,   636,  -228, -1000, -1000,    70,   636,   636,   636,  -228,
  -228,  -228,  -228,   636,   636,     9,   -16, -1000,   636,  1117,
 -1000, -1000,   636, -1000, -1000,  -228,    60,  -228,   636,  -228,
  -228,    65,  -228,  -228, -1000, -1000,    37, -1000,    30, -1000,
  -228,   636,   636,   636,    23,    20,   -76,   636,   636,   636,
   -85,   -88,   -93, -1000,   636,   636,  -107,  -110, -1000,   636,
  -128,   636,  -143,   636,  -194,   636,  -271,   636,  -224, -1000 };
int yypgo[]={

     0,     0,   361,   325,  1118,   235,   316,   303,   324,   179,
   242,   531,  1315,    35,   222,   473,    27,     1,   251,   320,
   317,   310,     2,   309,   300,   299,   296,   293,   288,   276,
   271,   267,   254,   243 };
int yyr1[]={

     0,    23,    23,    23,    23,    23,    24,    24,    24,    24,
    24,    24,    24,    24,    24,    24,    24,    24,    24,    24,
    24,    24,    24,    24,    24,    24,     6,     6,     6,    26,
     6,    18,    18,    18,    18,    25,    25,    25,    25,    17,
    17,    17,    17,    11,    11,    11,    12,    12,    12,    12,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    27,
    12,    28,    12,    29,    12,    30,    12,    31,    12,    32,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
    12,    12,    12,    15,    15,    15,    15,     8,     8,     9,
     9,    10,    10,    10,    16,    16,    16,    16,    13,    13,
    13,    14,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    21,    21,    22,    19,
    19,    20,    20,    20,    20,    20,     5,     5,     5,     5,
     7,    33,     7,     7,     4,     4,     4,     4,     4,     4,
     2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1 };
int yyr2[]={

     0,     1,     4,     5,     4,     5,     5,     5,     9,     5,
     5,    13,     5,     5,     5,     5,     5,     5,    17,    33,
    13,     5,     5,     5,     5,     5,     9,     3,     9,     1,
    13,     1,     5,     5,     5,     7,     3,     3,    11,     1,
     5,     5,    13,     1,     5,     5,    17,     5,     5,     9,
    13,     5,    13,    11,    13,     5,     5,     5,     5,     5,
     5,     9,     5,     5,     5,     5,    17,     5,     5,     1,
     7,     1,     7,     1,     7,     1,     7,     1,     7,     1,
     7,     5,     5,    11,     7,    13,    17,     5,     5,     5,
     5,     5,    17,    11,     3,    11,     7,     3,     5,     3,
     7,    15,    11,    15,    13,    17,    17,    53,     1,     5,
     5,     5,     9,     5,     5,    13,     9,    13,     5,     5,
     5,     5,     9,     5,    13,    13,     3,     7,    11,     1,
     5,    17,     5,     5,     5,     5,     1,     5,     5,     5,
    11,     1,    15,    11,     3,     7,     7,     7,     7,     3,
     3,     5,     7,    15,     7,     7,     3,     3,     3,    11,
     3,     3,     3,     7,     3,     7,     7,     7,     7,     5 };
int yychk[]={

 -1000,   -23,   -24,    -6,   -25,    -7,   292,   298,   341,   342,
   300,   321,   322,   323,   338,   346,   315,   314,   297,   301,
   303,   304,   324,   352,   259,   258,   257,   264,   -16,   -12,
   326,   290,   291,   289,   357,   272,   305,   269,   270,   273,
   283,   359,   288,   287,   286,   285,   360,   365,   284,   355,
   356,   328,   329,   349,   276,   327,   271,   279,   293,   299,
   347,   306,   263,   311,   281,   309,   351,   350,   358,   313,
   312,   264,    -1,   260,   261,   361,   325,   264,   278,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   295,   295,   296,   267,
   267,    -1,    -1,   262,    -1,   353,   354,   265,   264,   265,
   264,   265,   264,   371,   264,    -1,   267,   267,   267,   265,
   267,    -1,    -1,    -1,    -9,   -10,   267,    -1,   282,   259,
    -1,    -1,    -1,    -1,   264,   264,   264,   265,   264,   264,
   264,   264,    -1,   295,   296,   -27,   -28,   -29,   -30,   -31,
   -32,   295,   296,   264,   267,    -1,    -1,    -1,    -1,    -1,
   267,   366,   278,   367,   368,   264,    -1,   274,   274,    -1,
    -1,   274,   -11,   265,   -18,   265,   -26,   265,    -1,   302,
   265,    -1,    -1,    -1,    -1,    -1,   274,   274,    -1,   274,
    -2,    -3,   267,   264,   260,   261,   265,   274,    -8,    -9,
   274,   -15,    -1,   311,   -15,   -15,   -15,   -15,   -15,   265,
   -14,   317,   344,   343,   316,   318,   302,   319,   330,   320,
   335,   336,   331,   364,   363,   362,    -1,    -1,    -1,    -1,
    -1,    -1,   325,    -1,    -1,   274,   274,    -1,   266,   -16,
   -12,   264,   -11,   266,   -16,   -12,    -6,   259,   258,   257,
   -18,    -5,   -33,    -1,   -17,   274,   274,   274,   274,   274,
    -1,   -10,   274,    -1,   371,    -2,   366,   278,    -2,   369,
   -11,    -1,   266,    -9,    -1,   274,   264,   -13,   264,   265,
    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,   265,
    -1,    -1,    -1,   274,   274,   274,    -1,    -1,   274,   266,
   266,    -4,   -12,   -16,    -7,   259,   267,   264,   257,   258,
    -5,   274,   266,   -16,   259,   326,    -1,    -1,    -1,    -1,
    -1,   274,    -1,   274,    -1,    -2,    -2,   268,   265,   266,
   274,   274,    -1,   265,   -14,   266,   -14,   -16,   -21,   -22,
    -1,   274,   274,   274,   -19,   274,   274,    -1,    -1,    -1,
   274,   274,    -1,   266,   366,   367,   278,    -4,   259,   264,
    -4,    -1,    -1,   268,   274,   274,   274,   274,    -1,   274,
    -1,   282,   369,    -1,    -1,    -1,   274,   -13,   266,   274,
   274,    -1,    -1,    -1,   266,   -20,   272,   333,   332,   334,
   337,    -1,    -1,   274,   274,    -1,    -1,    -4,    -4,    -4,
   268,   266,   265,    -1,    -1,    -1,    -1,    -1,   274,   265,
   266,   274,    -1,   266,   -22,    -1,   274,   274,   267,    -1,
    -1,    -1,    -1,   274,   274,    -1,    -1,   268,   274,   -17,
   268,   268,   274,   268,   268,    -1,    -1,    -1,   274,    -1,
    -1,    -1,    -1,    -1,   268,   268,    -1,   266,    -1,   266,
    -1,   274,   274,   274,    -1,    -1,    -1,   274,   274,   274,
    -1,    -1,    -1,   268,   274,   274,    -1,    -1,   268,   274,
    -1,   274,    -1,   274,    -1,   274,    -1,   274,    -1,   266 };
int yydef[]={

     1,    -2,     2,     3,     4,     5,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    27,     0,     0,     0,    36,    37,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    69,    71,    73,    75,
    77,    79,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     6,     7,   160,   161,   162,     0,   164,     0,     0,
     9,    10,     0,    12,    13,    14,    15,    16,    17,     0,
     0,     0,    21,    22,    23,    24,    25,    43,     0,    31,
     0,    29,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    47,    48,     0,    51,    99,     0,     0,     0,     0,
     0,    55,    56,    57,    58,    59,    60,     0,    62,    63,
    64,    65,     0,    67,    68,     0,     0,     0,     0,     0,
     0,    81,    82,     0,     0,    87,    88,    89,    90,    91,
     0,     0,     0,     0,     0,     0,   169,     0,     0,     0,
     0,     0,     0,    43,     0,    31,   136,   141,    35,     0,
    39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   150,     0,   156,   157,   158,    43,     0,     0,    97,
     0,    70,    94,     0,    72,    74,    76,    78,    80,   108,
    84,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   165,   166,
   167,   168,   163,     8,     0,     0,     0,     0,    26,    44,
    45,     0,     0,    28,    32,    33,    34,    27,     0,     0,
     0,     0,   136,     0,     0,     0,     0,     0,     0,     0,
    49,   100,     0,     0,     0,   151,     0,     0,     0,     0,
     0,     0,    61,    98,     0,     0,     0,     0,   111,     0,
   113,   114,     0,     0,     0,   118,   119,   120,   121,   129,
   123,     0,     0,     0,     0,     0,     0,     0,     0,   140,
   143,     0,   137,   138,   139,   144,     0,   149,     0,     0,
     0,     0,    38,    40,    41,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   154,   155,   152,     0,    53,
     0,     0,     0,   108,    96,    83,   109,   110,     0,   126,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
     0,     0,    20,    30,     0,     0,     0,     0,   144,   149,
     0,    85,     0,   104,     0,     0,     0,     0,    50,     0,
   102,    52,     0,     0,    54,     0,     0,     0,   112,     0,
     0,     0,   116,     0,   122,   130,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   145,   146,   147,
   148,   142,    39,     0,     0,     0,     0,     0,     0,     0,
   159,     0,    93,    95,   127,     0,     0,     0,     0,   132,
   133,   134,   135,     0,     0,     0,     0,    18,     0,     0,
   105,   106,     0,    46,   101,   103,     0,    66,     0,   115,
   117,     0,   124,   125,    86,    92,     0,    42,     0,   153,
   128,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   131,     0,     0,     0,     0,    19,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   107 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"CSG",	257,
	"COMPOSITE",	258,
	"OBJECT_TYPE",	259,
	"FLOAT",	260,
	"INTEGER",	261,
	"FILETYPE",	262,
	"OPTION",	263,
	"NAME",	264,
	"LBRACE",	265,
	"RBRACE",	266,
	"LP",	267,
	"RP",	268,
	"RADIUS",	269,
	"RADII",	270,
	"COLOUR",	271,
	"CENTER",	272,
	"VERTEX",	273,
	"COMMA",	274,
	"PCENT",	275,
	"MATERIAL",	276,
	"REFI",	277,
	"MINUS",	278,
	"AMBIENT",	279,
	"INTENSITY",	280,
	"LOCATION",	281,
	"DOLS",	282,
	"EQUATION",	283,
	"OFFFILE",	284,
	"BASE",	285,
	"TOP",	286,
	"CONST",	287,
	"COEFFS",	288,
	"SCALE",	289,
	"ROTATE",	290,
	"TRANSLATE",	291,
	"TITLE",	292,
	"REFLECTANCE",	293,
	"DOT",	294,
	"ON",	295,
	"OFF",	296,
	"LOOKAT",	297,
	"FIELDOFVIEW",	298,
	"TRANSPARENCY",	299,
	"RAYSPERPIXEL",	300,
	"BACKGROUND",	301,
	"SIZE",	302,
	"MAXHITLEVEL",	303,
	"OUTPUT",	304,
	"ORDER",	305,
	"ABSORPTION",	306,
	"VREF1",	307,
	"VREF2",	308,
	"NUMRAYS",	309,
	"OBJECT",	310,
	"TEXTURE",	311,
	"DIRECTION",	312,
	"ANGLE",	313,
	"UP",	314,
	"TWENTYFIVEBIT",	315,
	"RANGE",	316,
	"MAP",	317,
	"BLENDCOLOR",	318,
	"SCALEFACTORS",	319,
	"VORTFILE",	320,
	"HAZECOLOUR",	321,
	"FOGFACTOR",	322,
	"RFACTOR",	323,
	"FALLOFF",	324,
	"QUOTE",	325,
	"REPEAT",	326,
	"SHADOWS",	327,
	"COLOURFILE",	328,
	"VNORMALFILE",	329,
	"SCALEFACTOR",	330,
	"SOURCE",	331,
	"AMPLITUDE",	332,
	"WAVELENGTH",	333,
	"PHASE",	334,
	"TURBULENCE",	335,
	"SQUEEZE",	336,
	"DAMPING",	337,
	"SOURCERADIUS",	338,
	"NORMAL",	339,
	"COMPLEXVERTEX",	340,
	"SCREENSIZE",	341,
	"MAXTREEDEPTH",	342,
	"BLEND",	343,
	"COLOURMAP",	344,
	"MAPVALUES",	345,
	"PIXELGRID",	346,
	"RI",	347,
	"COLOURBLEND",	348,
	"NORMALFILE",	349,
	"BEAMDISTRIBUTION",	350,
	"INSIDEANGLE",	351,
	"PROJECTION",	352,
	"PERSPECTIVE",	353,
	"ORTHOGRAPHIC",	354,
	"STRIP",	355,
	"VCOLOURFILE",	356,
	"TRANSFORM",	357,
	"MINDIST",	358,
	"CLIPVOLUME",	359,
	"HEIGHTFIELD",	360,
	"FRAMENO",	361,
	"BLOCKSIZE",	362,
	"GAPCOLOUR",	363,
	"GAPSIZE",	364,
	"COLOURFIELD",	365,
	"PLUS",	366,
	"MULT",	367,
	"DIV",	368,
	"POWER",	369,
	"UMINUS",	370,
	"EQUALS",	371,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"input : /* empty */",
	"input : input hitem",
	"input : input object",
	"input : input statement",
	"input : input definition",
	"hitem : TITLE NAME",
	"hitem : FIELDOFVIEW expr",
	"hitem : SCREENSIZE expr COMMA expr",
	"hitem : MAXTREEDEPTH expr",
	"hitem : RAYSPERPIXEL expr",
	"hitem : HAZECOLOUR expr COMMA expr COMMA expr",
	"hitem : FOGFACTOR expr",
	"hitem : RFACTOR expr",
	"hitem : SOURCERADIUS expr",
	"hitem : PIXELGRID ON",
	"hitem : TWENTYFIVEBIT ON",
	"hitem : TWENTYFIVEBIT OFF",
	"hitem : UP LP expr COMMA expr COMMA expr RP",
	"hitem : LOOKAT LP expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RP",
	"hitem : BACKGROUND expr COMMA expr COMMA expr",
	"hitem : MAXHITLEVEL expr",
	"hitem : OUTPUT FILETYPE",
	"hitem : FALLOFF expr",
	"hitem : PROJECTION PERSPECTIVE",
	"hitem : PROJECTION ORTHOGRAPHIC",
	"object : OBJECT_TYPE LBRACE body RBRACE",
	"object : OBJECT_TYPE",
	"object : COMPOSITE LBRACE compbody RBRACE",
	"object : CSG LBRACE",
	"object : CSG LBRACE csgbody csgexpr RBRACE",
	"compbody : /* empty */",
	"compbody : compbody transform",
	"compbody : compbody bodyitem",
	"compbody : compbody object",
	"statement : NAME EQUALS expr",
	"statement : transform",
	"statement : bodyitem",
	"statement : REPEAT expr LBRACE stlist RBRACE",
	"stlist : /* empty */",
	"stlist : stlist transform",
	"stlist : stlist OBJECT_TYPE",
	"stlist : stlist REPEAT expr LBRACE stlist RBRACE",
	"body : /* empty */",
	"body : body transform",
	"body : body bodyitem",
	"bodyitem : CENTER LP expr COMMA expr COMMA expr RP",
	"bodyitem : ORDER expr",
	"bodyitem : RADIUS expr",
	"bodyitem : RADII expr COMMA expr",
	"bodyitem : RADII expr COMMA expr COMMA expr",
	"bodyitem : VERTEX vbody",
	"bodyitem : EQUATION DOLS termlist EQUALS expr DOLS",
	"bodyitem : CLIPVOLUME OBJECT_TYPE LBRACE body RBRACE",
	"bodyitem : COEFFS expr COMMA expr COMMA expr",
	"bodyitem : CONST expr",
	"bodyitem : TOP expr",
	"bodyitem : BASE expr",
	"bodyitem : HEIGHTFIELD NAME",
	"bodyitem : COLOURFIELD NAME",
	"bodyitem : OFFFILE NAME",
	"bodyitem : STRIP LBRACE vlist RBRACE",
	"bodyitem : VCOLOURFILE NAME",
	"bodyitem : COLOURFILE NAME",
	"bodyitem : VNORMALFILE NAME",
	"bodyitem : NORMALFILE NAME",
	"bodyitem : MATERIAL expr COMMA expr COMMA expr COMMA expr",
	"bodyitem : SHADOWS ON",
	"bodyitem : SHADOWS OFF",
	"bodyitem : COLOUR",
	"bodyitem : COLOUR variation",
	"bodyitem : AMBIENT",
	"bodyitem : AMBIENT variation",
	"bodyitem : REFLECTANCE",
	"bodyitem : REFLECTANCE variation",
	"bodyitem : TRANSPARENCY",
	"bodyitem : TRANSPARENCY variation",
	"bodyitem : RI",
	"bodyitem : RI variation",
	"bodyitem : ABSORPTION",
	"bodyitem : ABSORPTION variation",
	"bodyitem : OPTION ON",
	"bodyitem : OPTION OFF",
	"bodyitem : TEXTURE NAME LBRACE texture_ops RBRACE",
	"bodyitem : TEXTURE NAME textitem",
	"bodyitem : NAME NAME SIZE expr COMMA expr",
	"bodyitem : LOCATION LP expr COMMA expr COMMA expr RP",
	"bodyitem : NUMRAYS expr",
	"bodyitem : INSIDEANGLE expr",
	"bodyitem : BEAMDISTRIBUTION expr",
	"bodyitem : MINDIST expr",
	"bodyitem : ANGLE expr",
	"bodyitem : DIRECTION LP expr COMMA expr COMMA expr RP",
	"variation : expr COMMA expr COMMA expr",
	"variation : expr",
	"variation : TEXTURE NAME LBRACE texture_ops RBRACE",
	"variation : TEXTURE NAME textitem",
	"vlist : vbody",
	"vlist : vlist vbody",
	"vbody : vitem",
	"vbody : vbody COMMA vitem",
	"vitem : LP expr COMMA expr COMMA expr RP",
	"vitem : expr COMMA expr COMMA expr",
	"vitem : expr COMMA expr COMMA expr COMMA expr",
	"transform : ROTATE LP expr COMMA expr RP",
	"transform : TRANSLATE LP expr COMMA expr COMMA expr RP",
	"transform : SCALE LP expr COMMA expr COMMA expr RP",
	"transform : TRANSFORM LBRACE expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RBRACE",
	"texture_ops : /* empty */",
	"texture_ops : texture_ops textitem",
	"texture_ops : texture_ops transform",
	"textitem : MAP NAME",
	"textitem : COLOURMAP LBRACE mbody RBRACE",
	"textitem : BLEND expr",
	"textitem : RANGE expr",
	"textitem : BLENDCOLOR expr COMMA expr COMMA expr",
	"textitem : SIZE expr COMMA expr",
	"textitem : SCALEFACTORS expr COMMA expr COMMA expr",
	"textitem : SCALEFACTOR expr",
	"textitem : VORTFILE NAME",
	"textitem : TURBULENCE expr",
	"textitem : SQUEEZE expr",
	"textitem : SOURCE LBRACE wbody RBRACE",
	"textitem : GAPSIZE expr",
	"textitem : GAPCOLOUR expr COMMA expr COMMA expr",
	"textitem : BLOCKSIZE expr COMMA expr COMMA expr",
	"mbody : mitem",
	"mbody : mbody COMMA mitem",
	"mitem : expr COMMA expr COMMA expr",
	"wbody : /* empty */",
	"wbody : wbody witem",
	"witem : CENTER LP expr COMMA expr COMMA expr RP",
	"witem : WAVELENGTH expr",
	"witem : AMPLITUDE expr",
	"witem : PHASE expr",
	"witem : DAMPING expr",
	"csgbody : /* empty */",
	"csgbody : csgbody bodyitem",
	"csgbody : csgbody transform",
	"csgbody : csgbody definition",
	"definition : OBJECT_TYPE NAME LBRACE body RBRACE",
	"definition : CSG NAME LBRACE",
	"definition : CSG NAME LBRACE csgbody csgexpr RBRACE",
	"definition : COMPOSITE NAME LBRACE compbody RBRACE",
	"csgexpr : OBJECT_TYPE",
	"csgexpr : csgexpr PLUS csgexpr",
	"csgexpr : csgexpr MULT csgexpr",
	"csgexpr : csgexpr MINUS csgexpr",
	"csgexpr : LP csgexpr RP",
	"csgexpr : NAME",
	"termlist : term",
	"termlist : termlist termlist",
	"termlist : LP termlist RP",
	"termlist : LP termlist RP POWER LBRACE expr RBRACE",
	"termlist : termlist PLUS termlist",
	"termlist : termlist MINUS termlist",
	"term : NAME",
	"term : FLOAT",
	"term : INTEGER",
	"term : NAME POWER LBRACE expr RBRACE",
	"expr : FLOAT",
	"expr : INTEGER",
	"expr : FRAMENO",
	"expr : QUOTE NAME QUOTE",
	"expr : NAME",
	"expr : expr PLUS expr",
	"expr : expr MINUS expr",
	"expr : expr MULT expr",
	"expr : expr DIV expr",
	"expr : MINUS expr",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 124 "gram.y"
{
		objdefined = FALSE;
	  } break;
case 3:
# line 129 "gram.y"
{
		object	*obj, *head;

		if ((head = objectinit(yypvt[-0].y_det->u.obj.sym, yypvt[-0].y_det->u.obj.det)) != (object *)NULL) {
			for (obj = head; obj->nxt != (object *)NULL; obj = obj->nxt)	
				;

			obj->nxt = oblist;
			oblist = head;
		}

		objdefined = TRUE;

		free(yypvt[-0].y_det);
	  } break;
case 5:
# line 146 "gram.y"
{
		objdefined = TRUE;

		free(yypvt[-0].y_det);
	  } break;
case 6:
# line 154 "gram.y"
{
		title = yypvt[-0].y_str;
	  } break;
case 7:
# line 158 "gram.y"
{
		float	val;

		val = eval_fexpr(yypvt[-0].y_exp);

		if (val == 0.0 || val == 360.0)
			fatal("art: idiotic angle in field of view.\n");

		focallength = focallength / tan(M_PI / 360.0 * val);
	  } break;
case 8:
# line 169 "gram.y"
{
		screenx = eval_fexpr(yypvt[-2].y_exp) / 2.0;
		screeny = eval_fexpr(yypvt[-0].y_exp) / 2.0;
	  } break;
case 9:
# line 174 "gram.y"
{
		maxtreedepth = eval_iexpr(yypvt[-0].y_exp);
	  } break;
case 10:
# line 178 "gram.y"
{
		raysperpix = eval_iexpr(yypvt[-0].y_exp);
		pixelgrid = (raysperpix > 1);
	  } break;
case 11:
# line 183 "gram.y"
{
		hazecolour.r = eval_fexpr(yypvt[-4].y_exp);
		hazecolour.g = eval_fexpr(yypvt[-2].y_exp);
		hazecolour.b = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 12:
# line 189 "gram.y"
{
		fogfactor = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 13:
# line 193 "gram.y"
{
		rfactor = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 14:
# line 197 "gram.y"
{
		sourceradius = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 15:
# line 201 "gram.y"
{
		pixelgrid = TRUE;
	  } break;
case 16:
# line 205 "gram.y"
{
		twentyfivebit(TRUE);
	  } break;
case 17:
# line 209 "gram.y"
{
		twentyfivebit(FALSE);
	  } break;
case 18:
# line 213 "gram.y"
{
		up.x = eval_fexpr(yypvt[-5].y_exp);
		up.y = eval_fexpr(yypvt[-3].y_exp);
		up.z = eval_fexpr(yypvt[-1].y_exp);
	  } break;
case 19:
# line 219 "gram.y"
{
		vector	t, u, s, eye;
		matrix	m, tmp;
		double	val, vy, vz, sinval, cosval;

		/*
		 * apply the twist
		 */
		val = eval_fexpr(yypvt[-1].y_exp) * M_PI / 180.0;
		sinval = sin(val);
		cosval = cos(val);
		mident4(m);
		m[0][0] = cosval;
		m[0][1] = -sinval;
		m[1][0] = sinval;
		m[1][1] = cosval;
		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);

		/*
		 * calculate the lookat
		 */
		eye.x = eval_fexpr(yypvt[-13].y_exp);
		eye.y = eval_fexpr(yypvt[-11].y_exp);
		eye.z = eval_fexpr(yypvt[-9].y_exp);

		t.x = eye.x - eval_fexpr(yypvt[-7].y_exp);
		t.y = eye.y - eval_fexpr(yypvt[-5].y_exp);
		t.z = eye.z - eval_fexpr(yypvt[-3].y_exp);

		u.x = up.x;
		u.y = up.y;
		u.z = up.z;

		normalise(t);

		normalise(u);

		vz = dprod(t, u);

		if (fabs(vz) >= 1.0)
			fatal("art: up vector and direction of view are the same.\n");

		vy = sqrt(1.0 - vz * vz);

		u.x = (u.x - vz * t.x) / vy;
		u.y = (u.y - vz * t.y) / vy;
		u.z = (u.z - vz * t.z) / vy;

		xprod(s, u, t);

		mident4(m);

		m[0][0] = s.x;
		m[0][1] = s.y;
		m[0][2] = s.z;

		m[1][0] = u.x;
		m[1][1] = u.y;
		m[1][2] = u.z;

		m[2][0] = t.x;
		m[2][1] = t.y;
		m[2][2] = t.z;

		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);

		mident4(m);
		m[3][0] = eye.x;
		m[3][1] = eye.y;
		m[3][2] = eye.z;
		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);
					/* set up initial trans data */
		mstackp->d.omused = TRUE;
		calctransforms(mstackp);
	  } break;
case 20:
# line 298 "gram.y"
{
		backcol.r = eval_fexpr(yypvt[-4].y_exp);
		backcol.g = eval_fexpr(yypvt[-2].y_exp);
		backcol.b = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 21:
# line 304 "gram.y"
{
		maxhitlevel = eval_iexpr(yypvt[-0].y_exp);
	  } break;
case 22:
# line 308 "gram.y"
{
		filetype = yypvt[-0].y_int;
	  } break;
case 23:
# line 312 "gram.y"
{
		falloff = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 24:
# line 316 "gram.y"
{
		perspective = TRUE;
	  } break;
case 25:
# line 320 "gram.y"
{
		perspective = FALSE;
	  } break;
case 26:
# line 326 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-3].y_sym;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 27:
# line 334 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-0].y_sym;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 28:
# line 342 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COMP_OBJ;
		yyval.y_det->u.obj.sym = (symbol *)NULL;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 29:
# line 350 "gram.y"
{
		if (ostackp->nxt == (objst *)NULL) {
			ostackp->nxt = (objst *)smalloc(sizeof(objst));
			ostackp->nxt->lst = ostackp;
			ostackp->nxt->nxt = (objst *)NULL;
		}

		ostackp = ostackp->nxt;
		ostackp->sym = (symbol *)NULL;
	  } break;
case 30:
# line 361 "gram.y"
{
		details	*d;
		symbol	*s;

		ostackp = ostackp->lst;

		d = (details *)smalloc(sizeof(details));
		d->type = yypvt[-2].y_det->type;
		d->u.csgobj.tree = yypvt[-1].y_csg;
		d->u.csgobj.det = yypvt[-2].y_det;
		d->nxt = (details *)NULL;

		s = (symbol *)smalloc(sizeof(symbol));
		s->type = CSG_OBJ;
		s->u.det = d;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = s;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 31:
# line 386 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 32:
# line 390 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
	  } break;
case 33:
# line 395 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
	  } break;
case 34:
# line 400 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
	  } break;
case 35:
# line 407 "gram.y"
{
		defvar(yypvt[-2].y_str, yypvt[-0].y_exp);
	  } break;
case 36:
# line 411 "gram.y"
{
		switch (yypvt[-0].y_det->type) {
		case TRANSLATE:
			translate(yypvt[-0].y_det->u.v.x, yypvt[-0].y_det->u.v.y, yypvt[-0].y_det->u.v.z);
			break;
		case SCALE:
			scale(yypvt[-0].y_det->u.v.x, yypvt[-0].y_det->u.v.y, yypvt[-0].y_det->u.v.z);
			break;
		case ROTATE:
			rotate(yypvt[-0].y_det->u.rot.ang, yypvt[-0].y_det->u.rot.axis);
			break;
		case TRANSFORM:
			transform(*yypvt[-0].y_det->u.trans.m);
			free(yypvt[-0].y_det->u.trans.m);
			break;
		default:
			fatal("art: bad transform type in switch.\n");
		}

		free(yypvt[-0].y_det);
	  } break;
case 37:
# line 433 "gram.y"
{
		surface	*s;

			/*
			 * don't want to change someone else's
			 * material properties
			 */
		if (objdefined) {
			s = (surface *)smalloc(sizeof(surface));
			*s = *astackp->d.s;
			astackp->d.s = s;
		} else
			s = astackp->d.s;

		switch (yypvt[-0].y_det->type) {
		case COLOUR:
			s->c.r = yypvt[-0].y_det->u.c.r;
			s->c.g = yypvt[-0].y_det->u.c.g;
			s->c.b = yypvt[-0].y_det->u.c.b;
			break;
		case AMBIENT:
			s->a.r = yypvt[-0].y_det->u.c.r;
			s->a.g = yypvt[-0].y_det->u.c.g;
			s->a.b = yypvt[-0].y_det->u.c.b;
			break;
		case TEXTURE:
			yypvt[-0].y_det->u.txt->nxt = astackp->d.txtlist;
			astackp->d.txtlist = yypvt[-0].y_det->u.txt;
			break;
		case MATERIAL:
			s->ri = yypvt[-0].y_det->u.mat.ri;
			s->kd = yypvt[-0].y_det->u.mat.kd;
			s->ks = yypvt[-0].y_det->u.mat.ks;
			s->ksexp = yypvt[-0].y_det->u.mat.ksexp;
			if (s->ri == 0.0)
				s->ri = 1.0;
			break;
		case REFLECTANCE:
			s->refl = yypvt[-0].y_det->u.c;
			break;
		case TRANSPARENCY:
			s->trans = yypvt[-0].y_det->u.c;
			break;
		case ABSORPTION:
			s->falloff = yypvt[-0].y_det->u.f;
			break;
		case ON:
			astackp->d.options |= yypvt[-0].y_det->u.i;
			break;
		case OFF:
			astackp->d.options &= ~yypvt[-0].y_det->u.i;
			break;
		case SHADOWS:
			astackp->d.s->shadows = yypvt[-0].y_det->u.i;
			break;
		default:
			fatal("art: bad statement type in switch.\n");
		}

		free(yypvt[-0].y_det);
	  } break;
case 38:
# line 495 "gram.y"
{
		dorepeat(yypvt[-3].y_exp, yypvt[-1].y_det);
	  } break;
case 39:
# line 501 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 40:
# line 505 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 41:
# line 510 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = yypvt[-0].y_sym;
		yyval.y_det->nxt = yypvt[-1].y_det;
	  } break;
case 42:
# line 518 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = REPEAT;
		yyval.y_det->u.rpt.expr = yypvt[-3].y_exp;
		yyval.y_det->u.rpt.stmt = yypvt[-1].y_det;
		yyval.y_det->nxt = yypvt[-5].y_det;
	  } break;
case 43:
# line 530 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 44:
# line 534 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 45:
# line 539 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 46:
# line 546 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CENTER;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 47:
# line 555 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ORDER;
		yyval.y_det->u.i = eval_iexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 48:
# line 562 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADIUS;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 49:
# line 569 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADII;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 50:
# line 577 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADII;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 51:
# line 586 "gram.y"
{
		if (yypvt[-0].y_det->nxt == (details *)NULL) {
			yypvt[-0].y_det->type = VERTEX;
			yyval.y_det = yypvt[-0].y_det;
		} else {
			yyval.y_det = (details *)smalloc(sizeof(details));
			yyval.y_det->type = COMPLEXVERTEX;
			yyval.y_det->u.det = yypvt[-0].y_det;
			yyval.y_det->nxt = (details *)NULL;
		}
	  } break;
case 52:
# line 598 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = EQUATION;
		yyval.y_det->u.t = (term *)smalloc(sizeof(term));
		yyval.y_det->u.t->coef = -eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->u.t->xp = 0;
		yyval.y_det->u.t->yp = 0;
		yyval.y_det->u.t->zp = 0;
		yyval.y_det->u.t->nxt = yypvt[-3].y_trm;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 53:
# line 610 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-3].y_sym;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 54:
# line 618 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COEFFS;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 55:
# line 627 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CONST;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 56:
# line 634 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TOP;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 57:
# line 641 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BASE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 58:
# line 648 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = HEIGHTFIELD;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 59:
# line 655 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOURFIELD;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 60:
# line 662 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OFFFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 61:
# line 669 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = STRIP;
		yyval.y_det->u.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 62:
# line 676 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VCOLOURFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 63:
# line 683 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOURFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 64:
# line 690 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VNORMALFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 65:
# line 697 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = NORMALFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 66:
# line 704 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MATERIAL;
		yyval.y_det->u.mat.ri = eval_fexpr(yypvt[-6].y_exp);
		yyval.y_det->u.mat.kd = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.mat.ks = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.mat.ksexp = eval_iexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 67:
# line 714 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SHADOWS;
		yyval.y_det->u.i = TRUE;
		yyval.y_det->nxt = (details *)NULL;

		astackp->d.shadows = TRUE;
	  } break;
case 68:
# line 723 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SHADOWS;
		yyval.y_det->u.i = FALSE;
		yyval.y_det->nxt = (details *)NULL;

		astackp->d.shadows = FALSE;
	  } break;
case 69:
# line 731 "gram.y"
{ fieldtype = COLOUR; } break;
case 70:
# line 732 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 71:
# line 735 "gram.y"
{ fieldtype = AMBIENT; } break;
case 72:
# line 736 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 73:
# line 739 "gram.y"
{ fieldtype = REFLECTANCE; } break;
case 74:
# line 740 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 75:
# line 743 "gram.y"
{ fieldtype = TRANSPARENCY; } break;
case 76:
# line 744 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 77:
# line 747 "gram.y"
{ fieldtype = RI; } break;
case 78:
# line 748 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 79:
# line 751 "gram.y"
{ fieldtype = ABSORPTION; } break;
case 80:
# line 752 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 81:
# line 756 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ON;
		yyval.y_det->u.i = yypvt[-1].y_int;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 82:
# line 763 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OFF;
		yyval.y_det->u.i = yypvt[-1].y_int;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 83:
# line 770 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-3].y_str, yypvt[-1].y_det, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 84:
# line 777 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-1].y_str, yypvt[-0].y_det, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 85:
# line 784 "gram.y"
{
		details	*d1, *d2;

		d1 = (details *)smalloc(sizeof(details));
		d1->type = VORTFILE;
		d1->u.s = yypvt[-4].y_str;

		d2 = (details *)smalloc(sizeof(details));
		d2->type = SIZE;
		d2->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		d2->u.v.y = eval_fexpr(yypvt[-0].y_exp);

		d1->nxt = d2;
		d2->nxt = (details *)NULL;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit("tile", d1, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 86:
# line 805 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CENTER;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 87:
# line 814 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = NUMRAYS;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 88:
# line 821 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = INSIDEANGLE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 89:
# line 828 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BEAMDISTRIBUTION;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 90:
# line 835 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MINDIST;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 91:
# line 842 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ANGLE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 92:
# line 849 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = DIRECTION;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 93:
# line 860 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = fieldtype;
		yyval.y_det->u.c.r = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.c.g = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 94:
# line 869 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = fieldtype;
		yyval.y_det->u.c.r = yyval.y_det->u.c.g = yyval.y_det->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 95:
# line 876 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-3].y_str, yypvt[-1].y_det, fieldtype);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 96:
# line 883 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-1].y_str, yypvt[-0].y_det, fieldtype);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 97:
# line 892 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		if (yypvt[-0].y_det->nxt == (details *)NULL)
			yyval.y_det->type = VERTEX;
		else
			yyval.y_det->type = COMPLEXVERTEX;
		yyval.y_det->u.det = yypvt[-0].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 98:
# line 902 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		if (yypvt[-0].y_det->nxt == (details *)NULL)
			yyval.y_det->type = VERTEX;
		else
			yyval.y_det->type = COMPLEXVERTEX;
		yyval.y_det->u.det = yypvt[-0].y_det;
		yyval.y_det->nxt = yypvt[-1].y_det;
	  } break;
case 99:
# line 914 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 100:
# line 918 "gram.y"
{
		if (yypvt[-0].y_det->nxt != (details *)NULL)
			yypvt[-0].y_det->nxt->nxt = yypvt[-2].y_det;
		else
			yypvt[-0].y_det->nxt = yypvt[-2].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 101:
# line 928 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VERTEX;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 102:
# line 937 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 103:
# line 946 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-6].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->nxt = (details *)smalloc(sizeof(details));
		yyval.y_det->nxt->type = TRANSPARENCY;
		yyval.y_det->nxt->u.c.r = yyval.y_det->nxt->u.c.g = yyval.y_det->nxt->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt->nxt = (details *)NULL;
	  } break;
case 104:
# line 960 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ROTATE;
		yyval.y_det->u.rot.ang = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.rot.axis = eval_iexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 105:
# line 968 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TRANSLATE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 106:
# line 977 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 107:
# line 989 "gram.y"
{
		matrix	m;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TRANSFORM;

		mident4(m);

		m[0][0] = eval_fexpr(yypvt[-23].y_exp);
		m[0][1] = eval_fexpr(yypvt[-21].y_exp);
		m[0][2] = eval_fexpr(yypvt[-19].y_exp);

		m[1][0] = eval_fexpr(yypvt[-17].y_exp);
		m[1][1] = eval_fexpr(yypvt[-15].y_exp);
		m[1][2] = eval_fexpr(yypvt[-13].y_exp);

		m[2][0] = eval_fexpr(yypvt[-11].y_exp);
		m[2][1] = eval_fexpr(yypvt[-9].y_exp);
		m[2][2] = eval_fexpr(yypvt[-7].y_exp);

		m[3][0] = eval_fexpr(yypvt[-5].y_exp);
		m[3][1] = eval_fexpr(yypvt[-3].y_exp);
		m[3][2] = eval_fexpr(yypvt[-1].y_exp);

		yyval.y_det->u.trans.m = (matrix *)smalloc(sizeof(matrix));

		minv4(*yyval.y_det->u.trans.m, m);

		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 108:
# line 1022 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 109:
# line 1026 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 110:
# line 1031 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 111:
# line 1038 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MAP;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 112:
# line 1045 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = MAPVALUES;
                yyval.y_det->u.cm = mapinit(yypvt[-1].y_det);
                yyval.y_det->nxt = (details *)NULL;
          } break;
case 113:
# line 1052 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLEND;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 114:
# line 1059 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RANGE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 115:
# line 1066 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLENDCOLOR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 116:
# line 1075 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SIZE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 117:
# line 1083 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALEFACTORS;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 118:
# line 1092 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALEFACTOR;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 119:
# line 1099 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VORTFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 120:
# line 1106 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TURBULENCE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 121:
# line 1113 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SQUEEZE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 122:
# line 1120 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = SOURCE;
                yyval.y_det->u.w = waveinit(yypvt[-1].y_det);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 123:
# line 1127 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = GAPSIZE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 124:
# line 1134 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = GAPCOLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 125:
# line 1143 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLOCKSIZE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 126:
# line 1154 "gram.y"
{
		yyval.y_det = (details *)NULL;
	} break;
case 127:
# line 1158 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-2].y_det;
		yyval.y_det = yypvt[-0].y_det;
	} break;
case 128:
# line 1165 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = MAPVALUES;
                yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
                yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
                yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 129:
# line 1175 "gram.y"
{
                yyval.y_det = (details *)NULL;
          } break;
case 130:
# line 1179 "gram.y"
{
                yypvt[-0].y_det->nxt = yypvt[-1].y_det;
                yyval.y_det = yypvt[-0].y_det;
          } break;
case 131:
# line 1186 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = CENTER;
                yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
                yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
                yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 132:
# line 1195 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = WAVELENGTH;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 133:
# line 1202 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = AMPLITUDE;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 134:
# line 1209 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = PHASE;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 135:
# line 1216 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = DAMPING;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 136:
# line 1226 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 137:
# line 1230 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 138:
# line 1235 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 139:
# line 1240 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 140:
# line 1247 "gram.y"
{
		defobj(yypvt[-3].y_str, yypvt[-4].y_sym->type, yypvt[-1].y_det);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = lookup(yypvt[-3].y_str);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 141:
# line 1257 "gram.y"
{
		if (ostackp->nxt == (objst *)NULL) {
			ostackp->nxt = (objst *)smalloc(sizeof(objst));
			ostackp->nxt->lst = ostackp;
			ostackp->nxt->nxt = (objst *)NULL;
		}

		ostackp = ostackp->nxt;
		ostackp->sym = (symbol *)NULL;
	  } break;
case 142:
# line 1268 "gram.y"
{
		details	*d;

		ostackp = ostackp->lst;

		d = (details *)smalloc(sizeof(details));

		d->type = yypvt[-1].y_csg->type;
		d->u.csgobj.tree = yypvt[-1].y_csg;
		d->u.csgobj.det = yypvt[-2].y_det;
		d->nxt = (details *)NULL;

		defobj(yypvt[-5].y_str, CSG_OBJ, d);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = lookup(yypvt[-5].y_str);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 143:
# line 1289 "gram.y"
{
		defobj(yypvt[-3].y_str, COMP_OBJ, yypvt[-1].y_det);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = lookup(yypvt[-3].y_str);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 144:
# line 1302 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = OBJECT;
		yyval.y_csg->u.sym = yypvt[-0].y_sym;
	  } break;
case 145:
# line 1308 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_ADD;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 146:
# line 1315 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_INT;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 147:
# line 1322 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_SUB;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 148:
# line 1329 "gram.y"
{
		yyval.y_csg = yypvt[-1].y_csg;
	  } break;
case 149:
# line 1333 "gram.y"
{
		char	buf[BUFSIZ];

		sprintf(buf, "art: object %s not defined.\n", yypvt[-0].y_str);
		fatal(buf);
	  } break;
case 150:
# line 1342 "gram.y"
{
		yyval.y_trm = yypvt[-0].y_trm;
	  } break;
case 151:
# line 1346 "gram.y"
{
		term	*t, *p, *np, *prod;

		prod = (term *)NULL;
		for (p = yypvt[-1].y_trm; p != (term *)NULL; p = p->nxt) {
			for (np = yypvt[-0].y_trm; np != (term *)NULL; np = np->nxt) {
				t = (term *)smalloc(sizeof(term));
				*t = *np;
				t->coef *= p->coef;
				t->xp += p->xp;
				t->yp += p->yp;
				t->zp += p->zp;
				t->nxt = prod;
				prod = t;
			}
		}

		for (t = yypvt[-1].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		for (t = yypvt[-0].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		yyval.y_trm = prod;
	  } break;
case 152:
# line 1376 "gram.y"
{
		yyval.y_trm = yypvt[-1].y_trm;
	  } break;
case 153:
# line 1380 "gram.y"
{
		term	*t, *p, *np, *prod, *nprod;
		int	i, power;

		prod = yypvt[-5].y_trm;
		power = eval_iexpr(yypvt[-1].y_exp);

		for (i = 1; i != power; i++) {		
			nprod = (term *)NULL;
			for (p = yypvt[-5].y_trm; p != (term *)NULL; p = p->nxt) {
				for (np = prod; np != (term *)NULL; np = np->nxt) {
					t = (term *)smalloc(sizeof(term));
					*t = *np;
					t->coef *= p->coef;
					t->xp += p->xp;
					t->yp += p->yp;
					t->zp += p->zp;
					t->nxt = nprod;
					nprod = t;
				}
			}
			if (prod != yypvt[-5].y_trm)
				for (t = prod; t != (term *)NULL; t = np) {
					np = t->nxt;
					free(t);
				}
			prod = nprod;
		}

		for (t = yypvt[-5].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		yyval.y_trm = prod;
	  } break;
case 154:
# line 1417 "gram.y"
{
		term	*p;

		for (p = yypvt[-0].y_trm; p->nxt != (term *)NULL; p = p->nxt)
			;
		yyval.y_trm = yypvt[-0].y_trm;
		p->nxt = yypvt[-2].y_trm;
	  } break;
case 155:
# line 1426 "gram.y"
{
		term	*p, *lp;

		for (p = yypvt[-0].y_trm; p != (term *)NULL; p = p->nxt) {
			p->coef *= -1.0;
			lp = p;
		}

		yyval.y_trm = yypvt[-0].y_trm;
		lp->nxt = yypvt[-2].y_trm;
	  } break;
case 156:
# line 1440 "gram.y"
{
		char	*p;

		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = 1;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;

		for (p = yypvt[-0].y_str; *p != 0; p++)
			switch (*p) {
			case 'x':
				yyval.y_trm->xp += 1;
				break;
			case 'y':
				yyval.y_trm->yp += 1;
				break;
			case 'z':
				yyval.y_trm->zp += 1;
				break;
			default:
				fatal("art: illegal name in equation.\n");
			}
	  } break;
case 157:
# line 1466 "gram.y"
{
		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = yypvt[-0].y_flt;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;
	  } break;
case 158:
# line 1475 "gram.y"
{
		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = yypvt[-0].y_int;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;
	  } break;
case 159:
# line 1484 "gram.y"
{
		char	*p;
		int	power;

		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = 1;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;

		power = eval_iexpr(yypvt[-1].y_exp);

		for (p = yypvt[-4].y_str; *p != 0; p++)
			switch (*p) {
			case 'x':
				yyval.y_trm->xp += 1;
				break;
			case 'y':
				yyval.y_trm->yp += 1;
				break;
			case 'z':
				yyval.y_trm->zp += 1;
				break;
			default:
				fatal("art: illegal name in equation.\n");
			}

		p--;

		switch (*p) {
		case 'x':
			yyval.y_trm->xp += power - 1;
			break;
		case 'y':
			yyval.y_trm->yp += power - 1;
			break;
		case 'z':
			yyval.y_trm->zp += power - 1;
			break;
		default:
			fatal("art: illegal name in equation.\n");
		}
	  } break;
case 160:
# line 1531 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_FLOAT;
		yyval.y_exp->u.f = yypvt[-0].y_flt;
	  } break;
case 161:
# line 1537 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = yypvt[-0].y_int;
	  } break;
case 162:
# line 1543 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = frameno;
	  } break;
case 163:
# line 1549 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = *yypvt[-1].y_str;
		free(yypvt[-1].y_str);
	  } break;
case 164:
# line 1556 "gram.y"
{
		yyval.y_exp = get_varexpr(yypvt[-0].y_str);
	  } break;
case 165:
# line 1560 "gram.y"
{
		yyval.y_exp = get_expr(EXP_ADD, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 166:
# line 1564 "gram.y"
{
		yyval.y_exp = get_expr(EXP_SUB, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 167:
# line 1568 "gram.y"
{
		yyval.y_exp = get_expr(EXP_MUL, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 168:
# line 1572 "gram.y"
{
		yyval.y_exp = get_expr(EXP_DIV, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 169:
# line 1576 "gram.y"
{
		yyval.y_exp = get_expr(EXP_UMINUS, yypvt[-0].y_exp, (expression *)NULL);
	  } break;
	}
	goto yystack;		/* reset registers in driver code */
}
